#include "windows.h"
#include "stdio.h"

#define IMPLEMENTS_DLL
#include "dll.h"


#ifdef __cplusplus
extern "C"{
#endif

LRESULT CALLBACK ShellProc(
	int			aCode, 
	WPARAM		aWParam, 
	LPARAM		aLParam 
	);

#ifdef __cplusplus
}
#endif


#pragma data_seg(".SHARDAT")
HINSTANCE	sInstance	= NULL;
HHOOK		sHook		= NULL;
HWND		sWindow		= NULL;
int			sMessage	= 0;
#pragma data_seg()


void WriteGlobalData()
{
	unsigned	value[3];

	FILE* file = fopen("c:\\deskwin.bin", "wb+");
	if (file)
	{
		value[0] = (unsigned) sHook;
		value[1] = (unsigned) sWindow;
		value[2] = (unsigned) sMessage;
		fwrite(&value[0], sizeof(value), 1, file);
		fclose(file);
	}
}

void ReadGlobalData()
{
	unsigned	value[3];

	FILE* file = fopen("c:\\deskwin.bin", "rb");
	if (file)
	{
		fread(&value[0], sizeof(value), 1, file);
		fclose(file);
		sHook = (HHOOK) value[0];
		sWindow = (HWND) value[1];
		sMessage = (int) value[2];
	}
}



BOOL WINAPI DllMain(
	HINSTANCE		aInstance, 
	DWORD			aReason, 
	LPVOID			aReserved 
	)
{
	if (!sInstance)
		sInstance = aInstance;

	return TRUE;
}


LRESULT CALLBACK ShellProc(
	int			aCode, 
	WPARAM		aWParam, 
	LPARAM		aLParam 
	)
{
	if (sHook == 0)
	{
		ReadGlobalData();
	}

	if (aCode < 0)
		return CallNextHookEx(sHook, aCode, aWParam, aLParam);

	CallNextHookEx(sHook, aCode, aWParam, aLParam);
	switch (aCode)
	{
		case HSHELL_WINDOWCREATED:
			PostMessage(sWindow, sMessage, aWParam, 1);
			break;

		// no need to inform that window is destroyed, this may actually crash win16 apps
		case HSHELL_WINDOWDESTROYED:
//			PostMessage(sWindow, sMessage, aWParam, 0);
			break;
		
		default:
			break;
	}

	return 0;
}
 

/*
 * Hmm, for some bizare reason it seems that in windows 9x/ME, the shared
 * data section solution doesn't work. As a result, we can't call the next
 * hook in the chain which causes the task bar to behave strangely.
 * The simplest solution is to just write the data to a file sothat other
 * threads can read them.
 *
 */


EXPORT_C void StartBackground(HWND aWindow, int aMessage)
{
	sWindow = aWindow;
	sMessage = aMessage;


	sHook = SetWindowsHookEx(
					WH_SHELL, 
					(HOOKPROC) ShellProc,
					sInstance, 
					0
					); 
	WriteGlobalData();
}

