/*******************************************************************
 *
 *	File:		CDeskwinEngineStore.cpp
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 1999, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#include "Deskwin.h"
#include "CDeskwinEngineStore.h"

void PruneReg

#define PERSIST_DESKTOP_BASE	REG_OPTION_ROOT _T("\\")  _T("Persist")
#define PERSIST_DESKTOP_KEY		_T("Desktop")
#define PERSIST_DESKTOP_STATE	_T("CleanShutDown")
#define PERSIST_DESKTOP_CURRENT	_T("CurrentDesktop")



void StoreWindowState(TWindow aWindow, bool aShow)
{
	HKEY	ourKey;
	char	name[9];
	DWORD	value;


	if(RegCreateKeyEx(
			HKEY_CURRENT_USER, 
			PERSIST_DESKTOP_BASE, 
			0, 
			0, 
			REG_OPTION_VOLATILE, 
			KEY_ALL_ACCESS, 
			NULL, 
			&ourKey,
			NULL) ==0) 
	{
		_snprintf(name, 9, "%8.8x", aWindow);
		value = aShow;
		RegSetValueEx(ourKey,name, 0, REG_DWORD, (unsigned char *) &value, sizeof(value));
		RegCloseKey(ourKey);
	}
}


void CDeskwinEngineStore::StoreDeskwinEngine(CDeskwinEngine& aDeskwinEngine)
{
}

void CDeskwinEngineStore::RestoreDeskwinEngine(CDeskwinEngine& aDeskwinEngine)
{
}


bool CDeskwinEngineStore::DeskwinEngineShutdownState()
{
}

void CDeskwinEngineStore::SetDeskwinEngineShutdownStateClean(CDeskwinEngine& aDeskwinEngine)
{
	for (int i=0 ; i<aDeskwinEngine.NoOfDesktops(); i++)
	{
		TCHAR		Text[128];
		sprintf(Text, _T("%s%i"), PERSIST_DESKTOP, d);
	}
}
