/*******************************************************************
 *
 *	File:		CInfoWindow.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 1999, 2000, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/



class CInfoWindow : public CWindowEx
{
public:
	CInfoWindow();
	void Construct(HWND aParent);
	void Popup(int aMouseX, int aMouseY);
	void SetInfoText(const string& aString){iInfoString.assign(aString);}
	void SetInfoText(int aResourceId);
protected:
	long OnWmTimer(WPARAM aWParam, LPARAM aLParam){OnTimer(); return 1;}
	void OnTimer();
	void Paint(CDC& dc);

	CPen	iPen;
	string	iInfoString;
};



