/*******************************************************************
 *
 *	File:		Deskwin.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 1999, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __DESKWIN_H
#define __DESKWIN_H

#pragma warning(disable: 4786)	// debug symbols > 256 characters
#pragma warning(disable: 4550)	// expression evaluates to a function which is missing an argument list

#include "CWindow.h"
#include "ccontrol.h"
#include "Debug.h"

typedef HWND TWindow;

#include <list>
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>

using namespace std;

#define MAJOR_VERSION 1
#define MINOR_VERSION 6
#define PATCH_VERSION 1
//#define PRE_RELEASE_VERSION	""


#define MAJOR_OPTION_VERSION _T("1")
#define MINOR_OPTION_VERSION _T("0")

#define REG_OPTION_ROOT _T("Software\\Suldrun\\Deskwin\\" MAJOR_OPTION_VERSION ".0")
#define PERSIST_DESKTOP_BASE	REG_OPTION_ROOT _T("\\")  _T("Persist")

__inline void GetScreenSize(long& aX, long& aY)
{
		/*
		 * Ugly way of getting the screen size
		 */
	RECT	rect;
	::GetWindowRect(::GetDesktopWindow(), &rect);
	aX = rect.right;
	aY = rect.bottom;
}


/*******************************************************************
 *
 * $Log: /Deskwin/Src/Deskwin.h $
 * 
 * 4     10/01/00 9:17 Pese
 * 
 * 3     5/01/00 20:26 Pese
 * 
 * 2     23/12/99 10:16 Pese
 *
 *******************************************************************/


#endif			/* __DESKWIN_H */